#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "graph.h"

#define PIC 5
#define DISPMAX 70

/*vg^Cv錾*/
unsigned char *load_ppm(const char *filename, int *width, int *height);
unsigned char *load_pgm(const char *filename, int *width, int *height);
int save_ppm(const char *filename, int width, int height, unsigned char *data);
int save_pgm(const char *filename, int width, int height, unsigned char *data);


/*SAD̎*/
int sad(int x, int y, unsigned char *img_l, unsigned char *img_r, int width, int height, int alpha){
  int i,j;
  int sum;
  int count;
  int pic=PIC;

  count=0;
  sum=0;
  for(i=-pic/2;i<=pic/2;i++){
    for(j=-pic/2;j<=pic/2;j++){
      if((x+i>=0) && (x+i<width) && (x-alpha+i>=0) && (y+j>=0) && (y+j<height)){
	count++;
	sum+=abs(img_l[x+i+(y+j)*width]-img_r[x+i-alpha+(y+j)*width]);
      }
    }
  }
  if(count!=0){
    sum=sum/count;
  }

  return sum;
}


/*̍œK*/
void henkan(unsigned char *img, int width, int height, unsigned char *ans, int max){
  int x,y,sa;
 
  if(max==0){
    max=255;
    printf("max erro");
  }
  sa=255/max;
 
  for(y=0;y<height;y++){
    for(x=0;x<width;x++){
      if(img[x+y*width]*sa<=255){
	ans[x+y*width]=img[x+y*width]*sa;
      }else{
	ans[x+y*width]=255;
      }
    }
  }
}


/*************************************************************
 * WAtB^[                                        *
 *************************************************************/

/*r֐*/
int compare(const int *a, const int *b)
{
  return *a - *b;
}

int median(unsigned char *img, int width, int height, unsigned char *mask)
{
  int x,y,max=0;
  int *median;

  median=(int *)malloc(8 * sizeof(int));
 
  for(y=1;y<height-1;y++){
    for(x=1;x<width-1;x++){
      median[0]=img[(x-1)+(y-1)*width];
      median[1]=img[(x)+(y-1)*width];
      median[2]=img[(x+1)+(y-1)*width];
      median[3]=img[(x-1)+(y)*width];
      median[4]=img[(x+1)+(y)*width];
      median[5]=img[(x-1)+(y+1)*width];
      median[6]=img[(x)+(y+1)*width];
      median[7]=img[(x+1)+(y+1)*width];
      qsort(median,7,sizeof(int),(int (*)(const void*, const void*))compare);
      mask[x+y*width]=median[3];
      if(max<median[3]) max=median[3];
    }
  }
  for(x=0;x<width;x++){
    mask[x+0*width]=img[x+0*width];
    mask[x+(height-1)*width]=img[x+(height-1)*width];
  }
  for(y=0;y<height;y++){
    mask[0+y*width]=img[0+y*width];
    mask[(width-1)+y*width]=img[(width-1)+y*width];
  }
  mask[0+0*width]=img[0+0*width];
  free(median);
  return max;
}



/********************************************************************
 * main֐
 ********************************************************************/
int main(int argc, char *argv[])
{
  clock_t start,end;
  int nodeNum,allnodeNum;
  int edgeNum,alledgeNum;
  int i,j,k,x,y,alpha;
  int width, height;
  unsigned char *data, *image_l, *image_r, *ans, *result;
  typedef Graph<int,int,int> GraphType;

  if(argc==3){
    printf("Ώۉ摜t@C1: %s\n", argv[1]);
    printf("Ώۉ摜t@C2: %s\n", argv[2]);
  }else if(argc<3){
    fprintf(stderr,"̐Ȃ܂!\n");
    fprintf(stderr,"R}h: ./graphcut 摜 E摜");
    return 1;
  }else{
    fprintf(stderr,"̐܂!\n");
    fprintf(stderr,"R}h: ./graphcut 摜 E摜");
    return 1;
  }

  start=clock(); //ԌvJn

  image_l = load_pgm(argv[1], &width, &height);
  image_r = load_pgm(argv[2], &width, &height);
  if(argc==4) ans = load_pgm(argv[3], &width, &height);
  
  printf("TCY: width=%d,height=%d\n",width,height);

  nodeNum=width*height;
  edgeNum=(width-1)*height+width*(height-1);
  allnodeNum=nodeNum+edgeNum;
  alledgeNum=(width+(width-1)-1)*height+width*(height+(height-1)-1);


  data = (unsigned char *)malloc(width*height);
  result = (unsigned char *)malloc(width*height);
  
  //l(͑SĂOƂ)
  /*
  for(y=0;y<height;y++){
    for(x=0;x<width;x++){
      data[x+y*width]=ans[x+y*width];
    }
  }
  */

 
  //烋[vɓ
  printf("\nPlease Wait...\n\n");
  int large=10000000;
  int LARGE=10000000;
  int success;
 
  for(j=0;j<LARGE;j++){
    success=0;
 
    for(alpha=0;alpha<64;alpha++){
      GraphType *g = new GraphType(/*estimated # of nodes*/ allnodeNum, /*estimated # of edges*/ alledgeNum);
  
      //sNZǉ
      x=0;
      y=0;
      for(i=0;i<nodeNum;i++){
	int sadd=sad(x,y,image_l,image_r,width,height,alpha);
	int sadd2=sad(x,y,image_l,image_r,width,height,data[x+y*width]);

	g->add_node();

	g->add_tweights(i,sadd2,sadd);
	
	x++;
	if(x>=width){
	  y++;
	  x=0;
	}
      }
  

      //אړ_ǉ(c)
      x=0;
      y=0;
      int addnum=0;
      for(i=0;i<width*(height-1);i++){

	if(data[x+y*width]==data[x+(y+1)*width]){
	  int v=abs(alpha-data[x+y*width]);
	  g->add_edge(i,i+width,v,v);
	}else{
	  int vb=abs(data[x+y*width]-data[x+(y+1)*width]);
	  int va=0;
	  g->add_node();
	  addnum++;
	  
	  g->add_tweights(i+nodeNum,vb,va);
	  
	  int vab=abs(alpha-data[x+(y+1)*width]);
	  int vba=abs(data[x+y*width]-alpha);
	  
	  g->add_edge(i,i+nodeNum,vba,vba);
	  g->add_edge(i+width,i+nodeNum,vab,vab);
	  
	  y++;
	  if(y>=height-1){
	    y=0;
	    x++;
	  }
	}
      }


      //̗אړ_ǉ
      int alll=nodeNum+addnum;
      for(i=0;i<(width-1)*height;i++){

	if(data[x+y*width]==data[x+1+y*width]){
	  int v=abs(alpha-data[x+y*width]);
	  g->add_edge(i,i+1,v,v);
	}else{
	  int vb=abs(data[x+y*width]-data[x+1+y*width]);
	  int va=0;
	  g->add_node();

	  g->add_tweights(i+alll,vb,va);
	
	  int vab=abs(alpha-data[x+1+y*width]);
	  
	  int vba=abs(data[x+y*width]-alpha);
	    
	  g->add_edge(i,i+alll,vba,vba);
	  g->add_edge(i+1,i+alll,vab,vab);
	  
	  x++;
	  if(x>=width-1){
	    y++;
	    x=0;
	  }
	}
      }
      
      //ő嗬EŏJbgASY̓Kp
      int flow=g->maxflow();
      if(flow<large){
	large=flow;
	success=1;
	x=0;
	y=0;
	for(i=0;i<nodeNum;i++){
	  //SOURCEɑĂ΍XV
	  if(g->what_segment(i)==GraphType::SOURCE){
	    data[x+y*width]=alpha;
	  }

	  x++;
	  if(x>=width){
	    y++;
	    x=0;
	  }
	}
      }
   
      delete g;
    }
    if(success==0) break;
  }

  //fBAtB^ɂ
  int max=median(data,width,height,result);

  //o͉摜̍œK
  henkan(result,width,height,data,max);

  //o
  save_pgm("result.pgm",width,height,data);

  free(image_l);
  free(image_r);
  if(argc==4) free(ans);
  free(data);
  free(result);

  end=clock();
  printf("COMPLETE!\n");
  printf("time: %.2f [s]\n",(double)(end-start)/CLOCKS_PER_SEC);
  return 0;
}
